local Framework=nil local FrameworkType=nil local function LoadConfig()local configFile=LoadResourceFile(GetCurrentResourceName(),'config.js')if configFile then local frameworkMatch=string.match(configFile,"framework:%s*['\"]([^'\"]+)['\"]")if frameworkMatch then FrameworkType=frameworkMatch print("[FiveMDash] Framework detected from config: "..FrameworkType)return true end end print("[FiveMDash] ERROR: Could not read framework from config.js")return false end local function LoadFramework()if not LoadConfig()then return false end if FrameworkType=='qb-core'or FrameworkType=='qb'then local success,result=pcall(function()return exports['qb-core']:GetCoreObject()end)if success and result then Framework=result print("[FiveMDash] QBCore loaded successfully")return true end elseif FrameworkType=='esx'then local success=false if exports['es_extended']then Framework=exports['es_extended']:getSharedObject()if Framework then success=true end end if not success and ESX then Framework=ESX success=true end if success then print("[FiveMDash] ESX loaded successfully")return true end elseif FrameworkType=='qbx'then if exports['qbx_core']then Framework={Functions=exports['qbx_core'],Player=exports['qbx_core'].GetPlayer}print("[FiveMDash] QBX loaded successfully")return true end end print("[FiveMDash] ERROR: Failed to load framework: "..FrameworkType)return false end local FrameworkFunctions={GetPlayer=function(source)if FrameworkType=='qb-core'or FrameworkType=='qb'then return Framework.Functions.GetPlayer(source)elseif FrameworkType=='esx'then return Framework.GetPlayerFromId(source)elseif FrameworkType=='qbx'then return exports['qbx_core']:GetPlayer(source)end end,GetPlayerName=function(player)if FrameworkType=='qb-core'or FrameworkType=='qb'then return player.PlayerData.name elseif FrameworkType=='esx'then return player.getName()elseif FrameworkType=='qbx'then return player.name end end,GetPlayerJob=function(player)if FrameworkType=='qb-core'or FrameworkType=='qb'then return player.PlayerData.job elseif FrameworkType=='esx'then return player.getJob()elseif FrameworkType=='qbx'then return player.job end end,IsPlayerAdmin=function(player)if FrameworkType=='qb-core'or FrameworkType=='qb'then local permission=player.PlayerData.permission return permission=='admin'or permission=='god'elseif FrameworkType=='esx'then local group=player.getGroup()return group=='admin'or group=='superadmin'elseif FrameworkType=='qbx'then return exports['qbx_core']:HasPermission(player.source,'admin')end end,Notify=function(source,message,type,duration)if FrameworkType=='qb-core'or FrameworkType=='qb'then TriggerClientEvent('QBCore:Notify',source,message,type,duration)elseif FrameworkType=='esx'then TriggerClientEvent('esx:showNotification',source,message)elseif FrameworkType=='qbx'then exports['qbx_core']:Notify(source,message,type,duration)end end,GetAllPlayers=function()if FrameworkType=='qb-core'or FrameworkType=='qb'then return Framework.Functions.GetQBPlayers()elseif FrameworkType=='esx'then return Framework.GetPlayers()elseif FrameworkType=='qbx'then local players={}for _,playerId in ipairs(GetPlayers())do local player=exports['qbx_core']:GetPlayer(tonumber(playerId))if player then players[playerId]=player end end return players end end}CreateThread(function()Wait(1000)if LoadFramework()then print("[FiveMDash] Server-Client Bridge initialized for "..FrameworkType)else print("[FiveMDash] ERROR: Framework could not be loaded!")end end)RegisterNetEvent('fivemdash:js:revivePlayer')AddEventHandler('fivemdash:js:revivePlayer',function(playerId)TriggerClientEvent('fivemdash:revivePlayer',playerId)print("[FiveMDash] Revive event triggered: "..playerId)end)RegisterNetEvent('fivemdash:js:healPlayer')AddEventHandler('fivemdash:js:healPlayer',function(playerId)TriggerClientEvent('fivemdash:healPlayer',playerId)print("[FiveMDash] Heal event triggered: "..playerId)end)RegisterNetEvent('fivemdash:js:setArmor')AddEventHandler('fivemdash:js:setArmor',function(playerId,amount)TriggerClientEvent('fivemdash:setArmor',playerId,amount)print("[FiveMDash] Armor event triggered: "..playerId..", Amount: "..amount)end)RegisterNetEvent('fivemdash:js:teleport')AddEventHandler('fivemdash:js:teleport',function(playerId,x,y,z)TriggerClientEvent('fivemdash:teleport',playerId,x,y,z)print("[FiveMDash] Teleport event triggered: "..playerId..", Location: "..x..", "..y..", "..z)end)RegisterNetEvent('fivemdash:js:teleportToMarker')AddEventHandler('fivemdash:js:teleportToMarker',function(playerId)TriggerClientEvent('fivemdash:teleportToMarker',playerId)print("[FiveMDash] Teleport to marker event triggered: "..playerId)end)RegisterNetEvent('fivemdash:js:spawnVehicle')AddEventHandler('fivemdash:js:spawnVehicle',function(playerId,vehicleData)TriggerClientEvent('fivemdash:spawnVehicle',playerId,vehicleData)if type(vehicleData)=="table"then print("[FiveMDash] Vehicle spawn event triggered: "..playerId..", Model: "..vehicleData.model)else print("[FiveMDash] Vehicle spawn event triggered: "..playerId..", Model: "..vehicleData)end end)RegisterNetEvent('fivemdash:js:giveWeapon')AddEventHandler('fivemdash:js:giveWeapon',function(playerId,weapon,ammo,attachments)TriggerClientEvent('fivemdash:giveWeapon',playerId,weapon,ammo,attachments)print("[FiveMDash] Give weapon event triggered: "..playerId..", Weapon: "..weapon)end)RegisterNetEvent('fivemdash:js:toggleNoclip')AddEventHandler('fivemdash:js:toggleNoclip',function(playerId)TriggerClientEvent('fivemdash:toggleNoclip',playerId)print("[FiveMDash] NoClip event triggered: "..playerId)end)RegisterNetEvent('fivemdash:js:toggleInvisibility')AddEventHandler('fivemdash:js:toggleInvisibility',function(playerId,state)TriggerClientEvent('fivemdash:toggleInvisibility',playerId,state)print("[FiveMDash] Invisibility event triggered: "..playerId..", State: "..tostring(state))end)RegisterNetEvent('fivemdash:js:setAdminOutfit')AddEventHandler('fivemdash:js:setAdminOutfit',function(playerId)TriggerClientEvent('fivemdash:setAdminOutfit',playerId)print("[FiveMDash] Admin outfit event triggered: "..playerId)end)RegisterNetEvent('fivemdash:notifyPanic')AddEventHandler('fivemdash:notifyPanic',function(x,y,z)local src=source local playerName=GetPlayerName(src)or"Unknown"if not Framework then print("[FiveMDash] ERROR: Framework not loaded for panic notification")return end local players=FrameworkFunctions.GetAllPlayers()for _,player in pairs(players)do if FrameworkFunctions.IsPlayerAdmin(player)then local adminSource=nil if FrameworkType=='qb-core'or FrameworkType=='qb'then adminSource=player.PlayerData.source elseif FrameworkType=='esx'then adminSource=player.source elseif FrameworkType=='qbx'then adminSource=player.source end if adminSource then FrameworkFunctions.Notify(adminSource,'PANIC! '..playerName..' needs help!','error',10000)end end end print("[FiveMDash] PANIC: "..playerName.." needs help! Location: "..x..", "..y..", "..z)end)RegisterNetEvent('fivemdash:setVehicleOwner')AddEventHandler('fivemdash:setVehicleOwner',function(netId,model,plate)local src=source local Player=FrameworkFunctions.GetPlayer(src)if Player then print("[FiveMDash] Vehicle ownership for "..GetPlayerName(src)..": "..model.." ("..plate..")")if FrameworkType=='qb-core'or FrameworkType=='qb'then local citizenid=Player.PlayerData.citizenid TriggerEvent('qb-vehiclekeys:server:SetVehicleOwner',plate,citizenid)elseif FrameworkType=='esx'then local identifier=Player.identifier MySQL.Async.execute('INSERT INTO owned_vehicles (owner, plate, vehicle) VALUES (@owner, @plate, @vehicle)',{['@owner']=identifier,['@plate']=plate,['@vehicle']=json.encode({model=GetHashKey(model),plate=plate})})elseif FrameworkType=='qbx'then exports['qbx_vehicles']:SetVehicleOwner(src,plate,model)end end end)RegisterNetEvent('fivemdash:clientLoaded')AddEventHandler('fivemdash:clientLoaded',function()local src=source print("[FiveMDash] Client loaded for player: "..src)TriggerClientEvent('fivemdash:setFramework',src,FrameworkType)end)exports('revivePlayer',function(playerId)TriggerClientEvent('fivemdash:revivePlayer',playerId)return true end)exports('healPlayer',function(playerId)TriggerClientEvent('fivemdash:healPlayer',playerId)return true end)exports('setPlayerArmor',function(playerId,amount)TriggerClientEvent('fivemdash:setArmor',playerId,amount)return true end)exports('teleportPlayer',function(playerId,x,y,z)TriggerClientEvent('fivemdash:teleport',playerId,x,y,z)return true end)exports('spawnVehicle',function(playerId,model,plate)local vehicleData={model=model,plate=plate or"ADMIN"..math.random(1000,9999)}TriggerClientEvent('fivemdash:spawnVehicle',playerId,vehicleData)return true end)exports('giveWeapon',function(playerId,weapon,ammo)TriggerClientEvent('fivemdash:giveWeapon',playerId,weapon,ammo or 100,{})return true end)exports('getFrameworkType',function()return FrameworkType end)CreateThread(function()Wait(2000)if Framework then print("[FiveMDash] Server-Client Bridge started successfully for "..FrameworkType)else print("[FiveMDash] WARNING: Framework not loaded properly!")end end)